
g_rioReportData = {} -- name, time
g_rioalertDeclinedPlayersTable = {}
g_rioalertTimeNextCheckLFGList = 0

function rioalertOnLoad()

	rioalert_frame:RegisterEvent("PLAYER_LOGIN")	
	rioalert_frame:RegisterEvent("LFG_LIST_ACTIVE_ENTRY_UPDATE")	
	rioalert_frame:RegisterEvent("LFG_LIST_APPLICANT_LIST_UPDATED")	
	rioalert_frame:RegisterEvent("LFG_LIST_APPLICANT_UPDATED")	
	rioalert_frame:RegisterEvent("PLAYER_ENTERING_WORLD")

end   

function rioalertOnEvent(self, event, ...)

	if event == "PLAYER_LOGIN" then
		rioalertSetupUI()
		rioalertShowHide()

	elseif event == "LFG_LIST_ACTIVE_ENTRY_UPDATE" or event ==  "LFG_LIST_APPLICANT_LIST_UPDATED" or event ==  "LFG_LIST_APPLICANT_UPDATED" then
		rioalertShowHide()
		rioalertCheckLFGList()

	elseif event == "PLAYER_ENTERING_WORLD" then
		if not rioalert_score then rioalertClickScoreToBase() end
		rioalertScoreToBaseScoreButton:SetText(rioalert_score)
	end

end

function rioalertSetupUI()

	local f = CreateFrame("Button", "rioalertDeclinePlayersButton", PVEFrame, "UIPanelButtonTemplate")
	f:SetPoint("TOPRIGHT", 0, 25)
	f:SetText("Decline")
	f:SetWidth(80)
	f:SetScript("OnClick",function(self, button, down) rioalertDeclineAll()  end )

	local f = CreateFrame("Button", "rioalertResetDeclinedPlayersButton", PVEFrame, "UIPanelButtonTemplate")
	f:SetPoint("TOPRIGHT", -80, 25)
	f:SetText("Reset") 
	f:SetWidth(80)
	f:SetScript("OnClick",function(self, button, down) rioalertResetAll()  end )

	local f = CreateFrame("Button", "rioalertScoreToBaseScoreButton", PVEFrame, "UIPanelButtonTemplate")
	f:SetPoint("TOPRIGHT", -200, 25)
	f:SetText("B") 
	f:SetScript("OnClick",function(self, button, down) rioalertClickScoreToBase()  end )

	local f = CreateFrame("Button", "rioalertLowerScoreButton", PVEFrame, "UIPanelButtonTemplate")
	f:SetPoint("TOPRIGHT", -200-40, 25)
	f:SetText("-") 
	f:SetScript("OnClick",function(self, button, down) rioalertClickLowerScore()  end )
	
	local f = CreateFrame("Button", "rioalertRaiseScoreButton", PVEFrame, "UIPanelButtonTemplate")
	f:SetPoint("TOPRIGHT", -200+40, 25)
	f:SetText("+") 
	f:SetScript("OnClick",function(self, button, down) rioalertClickRaiseScore()  end )


end

function rioalertGetClassColor(class)

	local c = strupper(class)

	if c == "DEATH KNIGHT"		then return 0.77, 	0.12, 	0.23   
	elseif c == "DRUID"			then return 1.00, 	0.49, 	0.04  
	elseif c == "HUNTER"		then return 0.67, 	0.83, 	0.45   
	elseif c == "MAGE"			then return 0.41, 	0.80, 	0.94    
	elseif c == "PALADIN"		then return 0.96, 	0.55, 	0.73   
	elseif c == "PRIEST"		then return 1.00, 	1.00, 	1.00    
	elseif c == "ROGUE"			then return 1.00, 	0.96, 	0.41   
	elseif c == "SHAMAN"		then return 0.0, 	0.44, 	0.87   
	elseif c == "WARLOCK"		then return 0.58, 	0.51, 	0.79   
	elseif c == "WARRIOR"		then return 0.78,	0.61, 	0.43   
	elseif c == "MONK"			then return 0.33, 	0.54, 	0.52 
	elseif c == "DEMONHUNTER"	then return 0.64,	0.19,	0.79   
	else
		return 1, 1, 1
	end

end

function rioalertGetShortName(destName)

	local n = destName
	local p = strfind(n, "-", 1, true)		

	if p and p > 1 then
		local short_name = strsub(n,0,p-1);
		if short_name then
			n = short_name
		end
	end

	return n

end

function riaRoleToText(tank, healer, damage)

	if tank then
		return "TANK"
	elseif healer then
		return "HEALER" 
	else
		return "DAMAGER"
	end

end

function rioalertGetRealmName(name)

	local n = name
	local p = strfind(n, "-", 1, true)		

	if p and p > 1 then
		local realm_name = strsub(n,p+1);
		if realm_name then
			n = realm_name
		end
	end

	return n

end

function rioalertCheckLFGList()

	
    local applicants = C_LFGList.GetApplicants()
	if applicants then
		for i=1, #applicants do
			local applicantInfo = C_LFGList.GetApplicantInfo(applicants[i])
		
			for j = 1, applicantInfo.numMembers do
				local fullName, class, _, level, itemLevel, _, tank, healer, damage, assignedRole = C_LFGList.GetApplicantMemberInfo(applicantInfo.applicantID, j)
    
				if fullName then

					local is_declined = false

					for k=1,#g_rioalertDeclinedPlayersTable do 
						if fullName == g_rioalertDeclinedPlayersTable[k] then
							is_declined = true
						end
					end

					if is_declined == false and applicantInfo.applicationStatus == "applied" then

						local shortname = rioalertGetShortName(fullName)
						local realm = rioalertGetRealmName(fullName) 
			
						if shortname and realm then

							local faction = 1
							if UnitFactionGroup("player") == "Horde" then
								faction = 2
							end
							
							local profile = RaiderIO.GetProfile( shortname, realm, faction )
						
							if profile then
								if rioalertAcceptApplicant(profile.mythicKeystoneProfile.currentScore, class, tank, healer, damage) then		
												
									local diff = profile.mythicKeystoneProfile.currentScore-rioalert_score																		
									local score_text = "(+" ..  diff  ..")"
									if diff < 0 then
										score_text = "(" .. diff .. ")"										
									end
										
									local found_index = 0

									for l=1,#g_rioReportData do

										local name = g_rioReportData[l][1]
										
										if name == fullName then
											found_index = l
											break
										end
										
									end

									local announce = false

									if found_index == 0 then
										local report_entry = { fullName, GetTime() }
										tinsert( g_rioReportData, report_entry)
										announce = true
									else
										if GetTime() > g_rioReportData[found_index][2] + 10 then
											announce = true
											g_rioReportData[found_index][2] = GetTime()
										end
									end

									if announce == true then
										DEFAULT_CHAT_FRAME:AddMessage( shortname .. " " .. class .. " "  .. riaRoleToText(tank, healer, damage)  .. " " .. score_text, rioalertGetClassColor(class) )										
										PlaySound(5761, "Master")	
									end
																																																							
								end							
							end 

						end

					end

				end
			end
        
		end
	end
end

function rioalertAcceptApplicant(score, class, role)

	local rio = score
	local min = rioalert_score
	if min then
		local diff = abs(min-rio)
		if score > min or diff <= 20 then
			return true
		end
	end

end

function rioalertClickRaiseScore()
	local v = tonumber(rioalertScoreToBaseScoreButton:GetText()) + 5
	rioalertScoreToBaseScoreButton:SetText(v)
	rioalert_score = v
end

function rioalertClickLowerScore()
	local v = tonumber(rioalertScoreToBaseScoreButton:GetText()) - 5
	rioalertScoreToBaseScoreButton:SetText(v)
	rioalert_score = v
end

function rioalertClickScoreToBase()
	local v = rioalertGetBaseKeystoneFromBackpack()
	rioalert_score = v
	rioalertScoreToBaseScoreButton:SetText(v)
end

function rioalertResetAll()
	g_rioalertDeclinedPlayersTable = {}
end

function rioalertDeclineAll()

    local applicants = C_LFGList.GetApplicants()
	if applicants then
		for i=1, #applicants do
			local applicantInfo = C_LFGList.GetApplicantInfo(applicants[i])
		
			for j = 1, applicantInfo.numMembers do
				local fullName, class, localizedClass, level, itemLevel, _, tank, healer, damage, assignedRole = C_LFGList.GetApplicantMemberInfo(applicantInfo.applicantID, j)
    
				if fullName then
					tinsert(g_rioalertDeclinedPlayersTable, fullName)
				end
			end
        
		end
	end
	
end

function rioalertShowHide()

	local listed = C_LFGList.HasActiveEntryInfo()

	if listed then
		if rioalertResetDeclinedPlayersButton then rioalertResetDeclinedPlayersButton:Show() end
		if rioalertDeclinePlayersButton then rioalertDeclinePlayersButton:Show() end
		if rioalertScoreToBaseScoreButton then rioalertScoreToBaseScoreButton:Show() end
		if rioalertLowerScoreButton then rioalertLowerScoreButton:Show() end
		if rioalertRaiseScoreButton then rioalertRaiseScoreButton:Show() end			
	else
		if rioalertResetDeclinedPlayersButton then rioalertResetDeclinedPlayersButton:Hide() end
		if rioalertDeclinePlayersButton then rioalertDeclinePlayersButton:Hide() end
		if rioalertScoreToBaseScoreButton then rioalertScoreToBaseScoreButton:Hide() end
		if rioalertLowerScoreButton then rioalertLowerScoreButton:Hide() end
		if rioalertRaiseScoreButton then rioalertRaiseScoreButton:Hide() end
	end

end

function rioalertGetBaseKeystoneFromBackpack()

	local rioAverangeKeyScore = { 0,300,250,300,375,425,525,575,650,800,850,950,1050,1300,1350,1400,1525,1675,1850,2025,2225,2450,2725,3000,3200,3350,3550 }

	for container=BACKPACK_CONTAINER, NUM_BAG_SLOTS do
		local slots = GetContainerNumSlots(container)
		for slot=1, slots do
			local _, _, _, _, _, _, slotLink, _, _, slotItemID = GetContainerItemInfo(container, slot)
			if slotLink and slotLink:match("|Hkeystone:") then

				local s1,s2 = strsplit("(", slotLink, 2)
				local s3,s4 = strsplit(")", s2, 2)

				if s3 then
					local n =  tonumber(s3) 

					if n > 1 and n <= 30 then
						return rioAverangeKeyScore[n]
					end
					
				end

			end
		end
	end

end